// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnContracts.C   Version 1.3
//   LastSCCS    : 1/23/92  12:33:07
//   LastEdit    : "Mon Jan 20 14:21:15 1992"
//   Description : Programming by contract in C++
//   Author      : Andreas Baecker
//   Copyright   : GMD Schloss Birlinghoven

void RequireCondition(int p_condition, char *msg, char *p_file, int p_line)
{
    if( ! p_condition ) {
	cerr << "Precondition violated: File " << p_file;
	cerr << ", Line " << p_line << "\n";
	if(msg)
	    cerr << "The condition violated is: " << msg << "\n";
	abort();
    }
}
	
void EnsureCondition(int p_condition, char *msg, char *p_file, int p_line)
{
    if( ! p_condition ) {
	cerr << "Postcondition violated: File " << p_file;
	cerr << ", Line " << p_line << "\n";
	if(msg)
	    cerr << "The condition violated is: " << msg << "\n";
	abort();
    }
}

void CheckCondition(int p_condition, char *msg, char *p_file, int p_line)
{
    if( ! p_condition ) {
	cerr << "Assertion violated: File " << p_file;
	cerr << ", Line " << p_line << "\n";
	if(msg)
	    cerr << "The assertion violated is: " << msg << "\n";
	abort();
    }
}
	
void CheckInvariant(GnContracts &p_object, char *p_file, int p_line)
{
    CheckInvariant(&p_object,p_file,p_line);
}

void CheckInvariant(GnContracts *p_object, char *p_file, int p_line)
{
    if( ! p_object->ClassInvariant() ) {
	cerr << "Class invariant violated for object ";
	cerr << (void *)p_object;
	cerr << "\n";
	cerr << "File " << p_file;
	cerr << " Line " << p_line << "\n";
	abort();
    }
}

int GnContracts::
ClassInvariant()
{
    return 1;
}



