// This may look like C code, but it is really -*- C++ -*-

//   Module      : Axiom.C   Version 1.2
//   LastSCCS    : 2/26/92  16:37:46
//   LastEdit    : "Mon Jan 27 13:17:53 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

ImplGenericListWithIterator(AxiomList,AxiomListIterator);

Axiom::
Axiom(Player *p_player,int p_shape, int p_color, int p_value, int p_n)
: PlayerLocation(p_player, p_shape, p_color, p_value)
{
    REQUIRE(p_n >= 0 && p_n <= 5, "Valid number of cards");
    REQUIRE(p_player != 0, "Player is non-zero");
    REQUIRE(shape != UndefShape || color != UndefColor || value != UndefValue,
	    "Something must be defined");
    
    n = p_n;
}

Axiom::
Axiom(Player *p_player, PlayerLocation *pl, int p_n)
: PlayerLocation(p_player, pl->GetShape(), pl->GetColor(), pl->GetValue())
{
    REQUIRE(p_n >= 0 && p_n <= 5, "Valid number of cards");
    REQUIRE(p_player != 0, "Player is non-zero");
    REQUIRE(shape != UndefShape || color != UndefColor || value != UndefValue,
	    "Something must be defined");
    
    n = p_n;
}

char *Axiom::
PrintOn(char *buffer, unsigned int length)
{
    REQUIRE( IsStringPresentable(), "Object has a string representation");
    REQUIRE( length > 0, "Positive length");

    ostrstream str(buffer, length, ios::out);

    str << SleuthDocument::ColorName(color);
    if( color != UndefColor )
	str << ' ';
    str << SleuthDocument::ShapeName(shape);
    if( shape != UndefShape )
	str << ' ';
    str << SleuthDocument::ValueName(value);
    if( value != UndefValue )
	str << "er ";
    str << "= " << n;
    str << '\0';
    buffer[length-1] = '\0';

    return buffer;
}

ostream &Axiom::
DumpOn(ostream &ostr)
{
    ostr << player->GetName() << " : ";
    ostr << SleuthDocument::ColorName(color) << " ";
    ostr << SleuthDocument::ShapeName(shape) << " ";
    ostr << SleuthDocument::ValueName(value) << " ";
    ostr << "= " << n;
    return ostr;
}

void Axiom::
RemoveSelf()
{
    player->Remove(this);
}

void Axiom::
AddSelf()
{
    player->Add(this);
}
