// This may look like C code, but it is really -*- C++ -*-

//   Module      : ZatDialog.h   Version 1.2
//   LastSCCS    : 2/26/92  16:39:07
//   LastEdit    : "Tue Nov  5 14:53:11 1991"
//   Description : 
//   Author      : Andreas Baecker
//   Copyright   : GMD Schloss Birlinghoven

#ifndef Zatdialog_h
#define Zatdialog_h

class ZatDialog : public UpdatedDialog {
  public:
    ZatDialog(SleuthDocument *p_document);
    char *DialogTitle()
	{ return "VP-Sleuth-Zug"; }
  protected:
    virtual void before_create(GnWidget *parent);
    virtual void after_create();
  public: // Updating
    virtual void Update();
  protected:
    virtual void Mapped();
    virtual void Unmapped();
  protected:  // Callbacks
    void NewGameName(caddr_t);
    void NewParticipant(caddr_t);
    void NoWhiteSpaceInString(caddr_t call_data);
  private:
    SleuthDocument *document;
    CardView        view;
    GnLabeledText   game_name;
    GnLabeledText   round;
    GnLabeledText   player_name;
    GnLabeledText   date;
    GnRowColumn     row_for_questions;
    GnLabeledText   questions[5];
};

#endif
