// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnClass.h   Version 1.8
//   LastSCCS    : 1/30/92  17:27:55
//   LastEdit    : "Mon Jan 20 10:36:51 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

#ifndef Gnclass_h
#define Gnclass_h

class GnClass : public GnPresentable {
    META_DEF_1(GnClass,GnPresentable);
  public:
    GnClass(char *n, unsigned int,
	    char *, int, char *, int,
	    GnBaseClassCollector, GnClassMemberCollector);
    virtual int IsSimpleType()
	{ return 0; }
    virtual int IsClassType()
	{ return 1; }
    virtual int StoreOn(ostream &ostr, char *addr);
    virtual int ReadFrom(istream &istr, char *addr);
    const char *Name() const
	{ return name; }
    const unsigned int Size() const
	{ return size; }
    const int MI() const
	{ return mi; }
    unsigned int ActiveInstances()
	{ return instance_count - deleted_instance_count; }
    unsigned int TotalInstances()
	{ return instance_count; }
    unsigned int DeletedInstances()
	{ return deleted_instance_count; }
    const char *DeclFileName()
	{ return decl_file_name; }
    const char *ImplFileName()
	{ return impl_file_name; }
    int DeclFileLine()
	{ return decl_file_line; }
    int ImplFileLine()
	{ return impl_file_line; }
    class GnClassInfoListIterator *BaseClassesIterator();
    class GnClassInfoListIterator *SubclassesIterator();
    static class GnClassListIterator *ClassListIterator();
    static int IsInitialized()
	{ return initialized; }
    static void Initialize();
    int IsSubclass(GnClass *);
    void *AmbiguousCast(void *, void *, GnClass *);
    void EnsureClassEqual(const GnClass *);
//     static int BaseStored(void *);
//     static void ClearBases();
    virtual char *PrintOn(char *buffer, unsigned int length);

  protected:
    void OrderNumbering(unsigned int *, unsigned int *);
  protected: 
    char                      *name;
    unsigned int               size;
    int                        mi;
    unsigned int               instance_count;
    unsigned int               deleted_instance_count;
    class GnClassInfoList     *base_classes;
    class GnClassInfoList     *sub_classes;
    class GnClassMemberList   *class_members;
    class GnClassOrderingList *ordering;
    GnBaseClassCollector       bc_collector;
    GnClassMemberCollector     cm_collector;
    char                      *decl_file_name, *impl_file_name;
    int                        decl_file_line, impl_file_line;
  protected:
    static class GnClassList           *class_list;
    static int                          initialized;
    static GnClass                     *root;
    static GnClassOrderingListIterator  oit_1, oit_2;
//    static GnLinkedList                 vbases;
};

DefGenericListWithIterator(GnClassList, GnClass, GnClassListIterator);

#endif
