// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnCommand.h   Version 1.16
//   LastSCCS    : 2/26/92  16:35:09
//   LastEdit    : "Mon Feb 24 16:23:26 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

#ifndef Gina_Command_H
#define Gina_Command_H

class GnDocument;
class GnView;

class GnCommand : public GnObject {
    META_DEF_1(GnCommand,GnObject);
    friend class GnView;
    friend class GnApplication;
    friend class GnDocument;
  public:
    GnCommand(GnDocument *, GnView * = NULL, Boolean create_checkpoint = FALSE );
  public:
    virtual char *name() = 0;
    virtual void submit();
  protected: // IO (optional)
    virtual Boolean IsStorable();
    virtual Boolean WriteToStream(ostream &p_ostr);
    virtual Boolean ReadFromStream(istream &p_istr);
  protected:
    virtual Boolean executable()    { return(True); };
    virtual Boolean undoable()      { return(True); };
    virtual Boolean clock_cursor()  { return(False); };
    virtual Boolean causes_change() { return(True); };

    virtual void doit ();
    virtual void redoit ();
    virtual void undoit ();
    virtual void commit ( Boolean undone );
    
    virtual void scroll_before_redo();
    virtual void scroll_before_undo ();

    void submit_to_framework ();
    
    void execute_undoit();
    void execute_redoit();

    void undoit_before();
    void redoit_before();


    GnDocument *document;
    GnView *view;
    int view_x_offset;
    int view_y_offset;
    //iostream *checkpoint;
};

DefGenericListWithIterator(GnCommandList,GnCommand,GnCommandListIterator);

#endif Gina_Command_H
