// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnGraphView.h   Version 1.1
//   LastSCCS    : 2/10/92  14:39:57
//   LastEdit    : "Tue Feb 25 15:05:45 1992"
//   Description : 
//   Author      : Andreas Genau
//   Copyright   : GMD Schloss Birlinghoven

#ifndef Gngraphview_h
#define Gngraphview_h

#include <CC/math.h>

class GnLayout;
class GnGraphView : public GnMultipleSelection, public GnView {
    META_DEF_2(GnGraphView,GnMultipleSelection,GnView);
  private:
    unsigned int m_node_number_of_chars;
    Dimension m_node_width, m_node_height, m_distance;
    Dimension m_vertical_distance, m_horizontal_distance;
    Direction m_direction;
    GnViewEdgeList m_edges;
    GnLayout *m_layouter;
  public:  
    GnGraphView(GnDocument *doc, unsigned int number_of_chars_in_node);
    void StringDraw(XmString string, int x, int y, Dimension width);
    void StringExtent(XmString string, Dimension *width, Dimension *height);
    void AddEdge(GnPresentable *source, GnPresentable *destination);
    void CallSelectionCallback();
    void SetVerticalDistance(Dimension d);
    void SetHorizontalDistance(Dimension d);
    GnLayout *SelectLayout(GnLayout *layouter);
    void SelectDirection(Direction dir)
	{ m_layouter->SetDirection(dir); DoLayout(); }
    void DeleteGraph();
    void DeleteEdge(GnViewEdge *edge);
    void DoLayout();
    virtual void resized();
    
  protected:   
    GnViewNode *FindViewNode(GnPresentable *node);
    
    //everything from GnMultipleSelection that has to spezialised
    
    virtual Boolean AllowChangeSensitivity(){ return(False); }
    virtual GnSelectionItem *create_item(GnPresentable *, Boolean, Boolean);
    virtual void Removed(GnSelectionItem *p_item);
    virtual void VisualizeItem(GnSelectionItem *item);
    virtual void UnvisualizeItem(GnSelectionItem *item);

};

#endif

