// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnMenuEntry.h   Version 1.20
//   LastSCCS    : 1/23/92  12:32:21
//   LastEdit    : "Mon Jan 20 17:34:42 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

#ifndef Gina_Menu_Entry_H
#define Gina_Menu_Entry_H

class GnMenuEntry : public GnObject {
    META_DEF_1(GnMenuEntry,GnObject);
  protected:
    GnMenuEntry(GnWidget *p_entry_widget,
		char *, char *, GnCallback *, Boolean);
  public:
    GnWidget *GetEntryWidget()
	{ return entry_widget; }
    char *get_name()
	{ return item_name; };
    virtual void set_label_string(char *new_label)
	{ item_label = new_label; };
    char *get_label_string()
	{ return item_label; };
    void set_sensitive(Boolean new_value);
    Boolean get_sensitive()
	{return sensitive;};
    void add_entryCallback(GnCallback *);
    void remove_entryCallback();
    GnItem *Item()
	{ return(item_value); };
    void Item(GnItem *item)
	{ item_value = item; };
  protected:
    virtual void attach_callback() {}
    virtual void detach_callback() {}
    char *item_name;
    char *item_label;
    GnItem *item_value;
    GnCallback *callback;
    Boolean sensitive;
  private:
    GnWidget *entry_widget;
};

DefGenericListWithIterator(GnMenuEntryList,GnMenuEntry,GnMenuEntryListIterator);

class GnPushButtonEntry : public GnPushButton, public GnMenuEntry {
    META_DEF_2(GnPushButtonEntry,GnPushButton,GnMenuEntry);
  public:
    GnPushButtonEntry(char *name, char *label, GnCallback *callback = 0,
		      Boolean = True);
    virtual void set_label_string(char *new_label);
  protected:
    virtual void attach_callback();
    virtual void detach_callback();
    virtual void before_create(GnWidget *);
    virtual void after_create();
};

DefGenericListWithIterator(GnPushButtonEntryList, GnPushButtonEntry,
			   GnPushButtonEntryIterator);

class GnToggleButtonEntry : public GnToggleButton, public GnMenuEntry {
    META_DEF_2(GnToggleButtonEntry,GnToggleButton,GnMenuEntry);
  public:
    GnToggleButtonEntry(char *name, char *label, Boolean set,
			GnCallback *callback = 0, Boolean = True);
    virtual void set_label_string(char *new_label);
  protected:
    virtual void attach_callback();
    virtual void detach_callback();
    virtual void before_create(GnWidget *);
    virtual void after_create();
    Boolean state;
};

DefGenericListWithIterator(GnToggleButtonEntryList, GnToggleButtonEntry,
			   GnToggleButtonEntryIterator);

#endif Gina_Menu_Entry_H
