/* @(#)GnPathname.h	1.16 7/29/91 */

#ifndef Gina_Pathname_H
#define Gina_Pathname_H

class GnPathnameList;

typedef enum Gstat {Gstat_OK, Gstat_FAILED, Gstat_NO};

char *Gget_work_dir(int *len = NULL);

class GnPathname : public GnObject {
    META_DEF_1(GnPathname,GnObject);
  public:
    /* Constructors: */
    GnPathname();		/* generiert pathname mit cwd */
    GnPathname(char *name, int do_stat = 0);
    GnPathname(char *name, char *type, char *directory, int do_stat = 0);

    operator char *();

    /* Destructor: */
    ~GnPathname();

    void set_directory( char * );
    void set_name( char * );
    void set_type( char * );
    
    /* Accessors: */
    char *directory() { return dir; };
    char *name()      { return nam; };
    char *type()      { return typ; };
    char *abs_namestring() { return abs_name; };
    char *rel_namestring() { return rel_name; };
    char *pattern();
    
    static char *basename(char *path, char *suffix = 0);
    static char *dirname(char *path);
    static char *filename(char *path);
    static char *normalize_dir(char *dir_path);

    /* Methods: */
    
    void merge_dir(char *);

    GnPathnameList *list_all_names_unsort();
    GnPathnameList *list_all_names();
    GnPathnameList *list_sub_directories();
    GnPathnameList *list_files();

    Gstat exists(char *p = NULL, struct stat *stat_buf_p = NULL);
    Gstat is_regular_file(u_short *prot = NULL);
    Gstat is_directory(u_short *prot = NULL);
    Gstat directory_valid(u_short *prot = NULL);
    Gstat writeable();
    Gstat writeable_or_createable();
    Gstat readable();

    int open_fd(int flags, int mode = 0);
    
  private:
    char *dir;
    char *nam;
    char *typ;
    char *abs_name;
    char *rel_name;
    int dirlen, namlen, typlen;

    void make_abs_and_rel_names();
    Gstat do_stat( char *, u_short, u_short, u_short *);

    int select( u_short ent_typ );
    int select_dirs();
    int select_files();
    int comp( GnPathname *pat );
    //GnPathnameList * scan_dir( int (GnPathname::*select_fct)() =NULL,
			      //int (GnPathname::*comp_fct)(GnPathname *) =NULL );
};

DefGenericList( GnPathnameList, GnPathname );

#endif Gina_Pathname_H
