// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnTimer.h   Version 1.10
//   LastSCCS    : 1/23/92  12:32:27
//   LastEdit    : "Mon Jan 20 13:35:31 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

#ifndef G_TIMER_H
#define G_TIMER_H

class GnTimer;
class GnCallback;

void TimerDispatcher(GnTimer *timer, XtIntervalId *id);

typedef void (*GnTimerCallbackProc) ( void *, void *, GnTimer *);

class GnTimer : public GnObject {
    META_DEF_1(GnTimer,GnObject);
    friend class GnCallback;
  public:
    GnTimer();
    GnTimer(unsigned int timer_interval, GnCallback *callback = 0,
	   Boolean initially_running = False, Boolean active_in_h = False,
	   Boolean active_in_loop = False);
    ~GnTimer();

    void add_callback(GnCallback *);
    void remove_callback(GnCallback *);
    
    void start(unsigned int new_timer_interval = 0);
    void restart(unsigned int new_timer_interval = 0);
    void stop();
    void destroy();

  protected:
    void install_timeout();
    void deinstall_timeout();

    unsigned int        interval;
    XtIntervalId        id;
    Boolean             destroyed;
    Boolean             enabled;
    Boolean             running;
    Boolean             active_in_handler;
    Boolean             active_in_recursive_main_loops;
    Boolean             busy;
    GnCallbackList       callbacks;
};

#endif G_TIMER_H
