// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnMenuEntry.C   Version 1.21
//   LastSCCS    : 1/23/92  12:34:01
//   LastEdit    : "Mon Jan 20 17:36:22 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

META_IMPL_1(GnMenuEntry,GnObject,);
ImplGenericListWithIterator(GnMenuEntryList,GnMenuEntryListIterator);
ImplGenericListWithIterator(GnPushButtonEntryList,GnPushButtonEntryIterator);
ImplGenericListWithIterator(GnToggleButtonEntryList,GnToggleButtonEntryIterator);

GnMenuEntry::
GnMenuEntry(GnWidget *p_entry_widget,
	    char *name, char *label,
	    GnCallback *cb, Boolean initially_sensitive)
{
    entry_widget = p_entry_widget;
    item_name = name;
    item_label = label;
    callback = cb;
    sensitive = initially_sensitive;
}

void GnMenuEntry::
set_sensitive(Boolean new_value)
{
    if( new_value != sensitive ) {
	sensitive = new_value;
	entry_widget->setR_sensitive(new_value);
	if( entry_widget->get_widget_id() != 0 )
	    entry_widget->SetValues();
    }
}

void GnMenuEntry::
add_entryCallback(GnCallback *cb)
{
    Require(callback == 0);

    callback = cb;
    attach_callback();
}

void GnMenuEntry::
remove_entryCallback()
{
    Require( callback != 0 );
    
    detach_callback();
    callback = 0;
}

META_IMPL_2(GnPushButtonEntry,GnPushButton,GnMenuEntry,);

GnPushButtonEntry ::
GnPushButtonEntry(char *name, char *label, GnCallback *callback, Boolean sens)
: GnPushButton(), GnMenuEntry((GnWidget *)this, name, label, callback, sens)
{
}

void GnPushButtonEntry::
attach_callback()
{
    add_activateCallback(callback);
}

void GnPushButtonEntry::
detach_callback()
{
    remove_activateCallback(callback);
}

void GnPushButtonEntry::before_create(GnWidget *)
{
    GnPushButton::setR_labelString(item_label);
    setR_sensitive(sensitive);
}

void GnPushButtonEntry::
after_create()
{
    if(callback)
	attach_callback();
}

void GnPushButtonEntry:: set_label_string(char *new_label)
{
    item_label = new_label;
    GnPushButton::setR_labelString(new_label);
    if( get_widget_id() != 0 )
	SetValues();
}

META_IMPL_2(GnToggleButtonEntry,GnToggleButton,GnMenuEntry,);

GnToggleButtonEntry::
GnToggleButtonEntry(char *name, char *label, Boolean set, GnCallback *callback,
		   Boolean sens)
: GnToggleButton(), GnMenuEntry((GnWidget *)this, name, label, callback, sens)
{
    state = set;
}

void GnToggleButtonEntry::before_create(GnWidget *)
{
    GnToggleButton::setR_labelString(item_label);
    setR_set(state);
    setR_sensitive(sensitive);
}

void GnToggleButtonEntry::
after_create()
{
    if(callback)
	attach_callback();
}

void GnToggleButtonEntry::
attach_callback()
{
    add_valueChangedCallback(callback);
}

void GnToggleButtonEntry::
detach_callback()
{
    remove_valueChangedCallback(callback);
}

void GnToggleButtonEntry:: set_label_string(char *new_label)
{
    item_label = new_label;
    GnToggleButton::setR_labelString(new_label);
    if( get_widget_id() != 0 )
	SetValues();
}
