/* @(#)GnPopupMenu.C	1.14 1/14/92 */

//#  define Object      XObject
//#  define String      XString
//#  undef String
//#  undef Object

#define BASE GnPopupMenuPane

META_IMPL_2(GnPopupMenu,GnPopupMenuPane,GnMenu,);

GnPopupMenu ::
GnPopupMenu()
: GnPopupMenuPane(), GnMenu((GnWidget *)this)
{
    label = new GnLabel;
    separator = new GnSeparator;
    items = new GnMenuItemList;
}

void GnPopupMenu ::
after_create()
{
    label->create( this, "Popup" );
    separator->create( this, "Separator" );
}

void GnPopupMenu ::
setR_labelString ( XmString lab )
{
    Require( label != 0 );
    Require( lab != 0 && strlen(lab)>0 );

    label->setR_labelString( lab );
}

void GnPopupMenu ::
pop_up ()
{
//    XmMenuPosition( group_widget_id, event );
    setR_x( 1 );
    setR_y( 1 );
    BASE :: pop_up();
}

void GnPopupMenu ::
add_item( char * item_name, GnMenuEntry *menu_entry )
{
    GnMenuItem *item = new GnMenuItem( item_name, menu_entry );
    menu_entry->create_entry( this );
    items->append( item );
}

void GnPopupMenu ::
remove_item( char * item_name )
{
    GnMenuItem *item;
    
    for ( items->start(); ! items->off(); items->forth() ) {
	item = items->item();
	if ( ! strcmp( item->get_name(), item_name ) ) {
	    item->destroy_entry();
	    items->remove();
	    break;
	}
    }
}
