// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnViewEdge.C   Version 1.4
//   LastSCCS    : 2/27/92  10:47:37
//   LastEdit    : "Tue Feb 25 15:05:16 1992"
//   Description : 
//   Author      : Andreas Genau
//   Copyright   : GMD Schloss Birlinghoven

META_IMPL_1(GnViewEdge,GnViewObject,);

ImplGenericListWithIterator(GnViewEdgeList,GnViewEdgeListIterator);

GnViewEdge::
GnViewEdge(GnGraphView *view, GnViewNode *source, GnViewNode *destination)
:GnViewObject(view->get_document()->gc_values(), 0, 0, True)
{
    m_view = view;
    m_hidden = True;
    m_source = source;
    m_destination = destination;
    m_x_begin = 0; m_y_begin = 0;  m_x_end = 0; m_y_end = 0;
}

GnViewEdge::
~GnViewEdge()
{
    Hide();
    m_destination->RemoveEdgeFrom(this);
    m_source->RemoveEdgeTo(this);
}

void GnViewEdge::
draw(int count, int x, int y, Dimension width, Dimension height)
{
    m_view->draw_line(m_x_begin, m_y_begin, m_x_end, m_y_end, False);
}

void GnViewEdge::
AdjustEnclosingRectangle()
{
    if (m_x_begin <= m_x_end && m_y_begin <= m_y_end){
	move(m_x_begin, m_y_begin, False);
	resize(m_x_end - m_x_begin + 1, m_y_end - m_y_begin + 1, False);
    }
    else if (m_x_begin <= m_x_end && m_y_begin > m_y_end){
	move(m_x_begin, m_y_end, False);
	resize(m_x_end - m_x_begin + 1, m_y_begin - m_y_end + 1, False);
    }
    else if (m_x_begin > m_x_end && m_y_begin <= m_y_end){
	move(m_x_end, m_y_begin, False);
	resize(m_x_begin - m_x_end + 1, m_y_end - m_y_begin + 1, False);
    }
    else if (m_x_begin > m_x_end && m_y_begin > m_y_end){
	move(m_x_end, m_y_end, False);
	resize(m_x_begin - m_x_end + 1, m_y_begin - m_y_end + 1, False);
    }
}

void GnViewEdge::
SetBeginCoordinates(int x, int y)
{
    m_x_begin = x; m_y_begin = y;
    AdjustEnclosingRectangle();
}

void GnViewEdge::
SetEndCoordinates(int x, int y)
{
    m_x_end = x; m_y_end = y;
    AdjustEnclosingRectangle();
}

void GnViewEdge::
Visualize()
{
    Require(m_view);
    Require(m_view->IsMotifWidgetCreated());
    if (m_hidden){
	install(m_view, 0, 0, False);
        m_hidden = False;
}   }

void GnViewEdge::
Hide()
{
    if (!m_hidden){
	deinstall(False);
	m_hidden = True;
}   }

