// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnMessageD.C   Version 1.22
//   LastSCCS    : 1/14/92  15:18:21
//   LastEdit    : "Mon Jan 13 12:47:22 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

extern "C" {
    extern Widget XmCreateMessageDialog(Widget, char *, Arg *, int);
}

META_IMPL_2(GnMessageDialog,GnMessageBox,GnDialogMixin,);

GnMessageDialog::
GnMessageDialog()
: GnMessageBox(), GnDialogMixin((GnBulletinBoard *)this)
{
}

Widget GnMessageDialog ::
create_widget(GnWidget *par, char * widget_name)
{
    return XmCreateMessageDialog(par->get_widget_id_for_sons(), widget_name,
			         args, args_n);
}

void GnMessageDialog::
after_create()
{
    secret_dialog_shell.encapsulate_self(XtParent(widget_id));
    secret_dialog_shell.SetValues();
}

DialogResult GnMessageDialog::
alert_message_dialog(GnWidget &parent,
		     char * message, char * title, char * dialog_name,
		     unsigned char default_button,
		     unsigned char dialog_style,
		     DialogResult wm_closed_result,
		     Boolean has_ok_button,
		     Boolean has_cancel_button,
		     Boolean has_help_button,
		     DialogResult ok_result,
		     DialogResult cancel_result,
		     DialogResult help_result)
{
    XmString xm_message, xm_title;
    DialogResult result;
    
    xm_message = XmStringCreateLtoR(message, XmSTRING_DEFAULT_CHARSET);
    xm_title = XmStringCreateLtoR(title, XmSTRING_DEFAULT_CHARSET);
    setR_defaultButtonType(default_button);
    setR_messageString(xm_message);
    setR_dialogTitle(xm_title);
    setR_dialogStyle(dialog_style);
    setR_autoUnmanage(False);
    create(parent, dialog_name);
    if(has_ok_button)
	auto_popdown_button(getR_okButton(), ok_result);
    else
	getR_okButton()->unmanage();
    if(has_cancel_button)
	auto_popdown_button(getR_cancelButton(), cancel_result);
    else
	getR_cancelButton()->unmanage();
    if(has_help_button)
	auto_popdown_button(getR_helpButton(), help_result);
    else
	getR_helpButton()->unmanage();
    result = alert(wm_closed_result);
    //destroy();
    XmStringFree(xm_message);
    XmStringFree(xm_title);
    return(result);
}

DialogResult message_dialog(GnWidget &parent, char * message, char * title,
			    unsigned char default_button,
			    unsigned char dialog_style)
{
    GnMessageDialog dialog;

    return dialog.alert_message_dialog(parent, message, title,
				       "MessageDialog",
				       default_button, dialog_style,
				       OK, True, True, False);
}

