// This may look like C code, but it is really -*- C++ -*-

//   Module      : GnRadioGroup.C   Version 1.9
//   LastSCCS    : 1/23/92  12:33:30
//   LastEdit    : "Mon Jan 20 14:08:47 1992"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

META_IMPL_2(GnRadioGroup,GnSelectionFrame,GnSingleSelection,);

GnRadioGroup::
GnRadioGroup(Boolean p_call_immediately)
: GnSingleSelection(False, p_call_immediately)
{
}    

extern "C" {
    extern Widget XmCreateRadioBox(Widget, char *, Arg *, int);
}

Widget GnRadioGroup::
create_widget(GnWidget *, char * widget_name)
{
    return(XmCreateRadioBox(frame.get_widget_id_for_sons(),
			    widget_name, args, args_n));
}

GnSelectionItem *GnRadioGroup::
create_item(GnPresentable *obj, Boolean sel, Boolean sens)
{
    return new GnToggleSelectionItem(obj, sel, sens);
}

void GnRadioGroup::
SelectItemWidget(GnSelectionItem *i, Boolean state, Boolean )
{
    GnToggleSelectionItem *item = (GnToggleSelectionItem *)i;

    Require(item->button != 0);

    item->button->SetState(state, True);
}

void GnRadioGroup::
SensitiveItemWidget(GnSelectionItem *i, Boolean state)
{
    GnToggleSelectionItem *item = (GnToggleSelectionItem *)i;

    Require(item->button != 0);

    item->button->setR_sensitive(state);
    item->button->SetValues();
}

void GnRadioGroup::
VisualizeItem(GnSelectionItem *i)
{
    if( IsMotifWidgetCreated() ) {
	GnToggleSelectionItem *item = (GnToggleSelectionItem *)i;
	char n[100];
	
	item->button = new GnToggleButton;
	item->button->setR_set(item->Selected());
	item->button->setR_sensitive(item->Sensitive());
	item->button->setR_labelString(item->Value()->PrintOn(n,100));
	item->button->create(this, "GnToggleSelectionItem");
	item->callback = CALLBACK1(GnRadioGroup, change_value, this,
				   GnSelectionItem *, item);
	item->button->add_valueChangedCallback(item->callback);
    }
}

GnWidget *GnRadioGroup::
get_group_widget()
{
    return (GnWidget *)&outer_row;
}

void GnRadioGroup::
before_create(GnWidget *parent)
{
    CheckSelectedItems();
    GnSelectionFrame::before_create(parent);
}

void GnRadioGroup::
after_create()
{
    REQUIRE( ! entries.Empty(), "List of items is not empty" );
    
    VisualizeAllItems();
}

void GnRadioGroup::
SetValues()
{
    //GnSingleSelection::SetValues();
    GnSelectionFrame::SetValues();
}

void GnRadioGroup ::
change_value(void *client_data, caddr_t call_data)
{
    XmToggleButtonCallbackStruct *cbs =
	(XmToggleButtonCallbackStruct *)call_data;

    if( cbs->set )
	GnSingleSelection::change_value(client_data, call_data);
}

META_IMPL_1(GnPixmapRadioGroup,GnRadioGroup,);

GnPixmapRadioGroup::
GnPixmapRadioGroup(Boolean p_call_immediately)
: GnRadioGroup(p_call_immediately)
{
}    

void GnPixmapRadioGroup::
VisualizeItem(GnSelectionItem *i)
{
    if( IsMotifWidgetCreated() ) {
	GnToggleSelectionItem *item = (GnToggleSelectionItem *)i;
    
	REQUIRE(item->Value()->IsBitmapPresentable(),
		"Item has a bitmap representation");

	item->button = new GnToggleButton;
	item->button->setR_set(item->Selected());
	item->button->setR_sensitive(item->Sensitive());
	item->button->setR_labelType(XmPIXMAP);
	if(item->Value()->HasBitmapBits()) {
	    unsigned int w, h;
	    item->button->setR_labelPixmap(item->Value()->BitmapBits(w, h),
					   w, h);
	}
	else {
	    item->button->setR_labelPixmap(item->Value()->BitmapFileName());
	}
	item->button->setR_indicatorOn(False);
	item->button->create(this, "GnToggleSelectionItem");
	item->callback = CALLBACK1(GnRadioGroup, change_value, this,
				   GnSelectionItem *, item);
	item->button->add_valueChangedCallback(item->callback);
    }
}






