/* @(#)GscrolledW.C	1.19 3/4/91 */


extern "C" {
extern Widget XmCreateScrolledWindow(Widget, char *, Arg *, int);
}

META_IMPL_1(GnScrolledWindow,GnManager,);

GnScrolledWindow :: GnScrolledWindow() 
{
    vertical_scrollbar = 0;
    horizontal_scrollbar = 0;
    clip_window = 0;
    work_area = 0;
}

Widget GnScrolledWindow ::
create_widget(GnWidget *par, char * widget_name)
{
    return(XmCreateScrolledWindow(par->get_widget_id_for_sons(), widget_name, 
				   args, args_n));
}

void GnScrolledWindow ::
before_create(GnWidget *)
{
    // Force Resources to their default settings

    setR_scrollBarDisplayPolicy(XmSTATIC);
    setR_scrollingPolicy(XmAPPLICATION_DEFINED);
    setR_visualPolicy(XmVARIABLE);
}

void GnScrolledWindow::
after_create()
{
}

void GnScrolledWindow::son_created(GnWidget *child)
{
    work_area = child;
    Gina_Debug("GnScrolledWindow :: son_created work_area = ");
    Gina_Debug_NL((void*)child);
    Gina_Debug("GnScrolledWindow :: son_created this = ");
    Gina_Debug_NL((void*)this);
}

void GnScrolledWindow::
register_scrolled_child(GnWidget *work_area_son)
{
    work_area = work_area_son;
    Gina_Debug("GnScrolledWindow :: register_scrolled_child work_area = ");
    Gina_Debug_NL((void*)work_area);
    Gina_Debug("GnScrolledWindow :: register_scrolled_child:: this = ");
    Gina_Debug_NL((void*)this);
}

void GnScrolledWindow ::
setR_horizontalScrollBar(GnScrollBar *bar)
{
    Require(horizontal_scrollbar == 0);

    horizontal_scrollbar = bar;
    set_arg(XmNhorizontalScrollBar, (XtArgVal)(bar->get_widget_id()));
}

GnScrollBar * GnScrolledWindow::
getR_horizontalScrollBar()
{
    Widget w;

    if( ! horizontal_scrollbar && getR_scrollingPolicy() == XmAUTOMATIC) {
	get_arg(XmNhorizontalScrollBar, (XtArgVal)&w);
	horizontal_scrollbar = new GnScrollBar;
	horizontal_scrollbar->encapsulate_self(w);
    }
    return(horizontal_scrollbar);
}

void GnScrolledWindow ::
setR_verticalScrollBar(GnScrollBar *bar)
{
    Require(vertical_scrollbar == 0);

    vertical_scrollbar = bar;
    set_arg(XmNverticalScrollBar, (XtArgVal)(bar->get_widget_id()));
}

GnScrollBar * GnScrolledWindow::
getR_verticalScrollBar()
{
    Widget w;

    if( ! vertical_scrollbar && getR_scrollingPolicy() == XmAUTOMATIC ) {
	get_arg(XmNverticalScrollBar, (XtArgVal)&w);
	vertical_scrollbar = new GnScrollBar;
	vertical_scrollbar->encapsulate_self(w);
    }
    return(vertical_scrollbar);
}

GnWidget * GnScrolledWindow::
getR_clipWindow()
{
    Widget w;

    if( ! clip_window && getR_scrollingPolicy() == XmAUTOMATIC ) {
	get_arg(XmNclipWindow, (XtArgVal)&w);
	clip_window = new GnWidget;
	clip_window->encapsulate_self(w);
    }
    return(clip_window);
}

META_IMPL_1(GnVariableScrolledWindow,GnScrolledWindow,);

Widget GnVariableScrolledWindow::create_widget(GnWidget *par, char *n)
{
    return(GnScrolledWindow::create_widget(par, n));
}

void GnVariableScrolledWindow::
before_create(GnWidget *)
{
    // Force Resources to specific values

    setR_scrollBarDisplayPolicy(XmAS_NEEDED);
    setR_scrollingPolicy(XmAUTOMATIC);
    setR_visualPolicy(XmCONSTANT);
}

void GnVariableScrolledWindow::
after_create()
{
    // Get the automatically created children of ScrolledWindow and
    // encapsulate them
    getR_horizontalScrollBar();
    getR_verticalScrollBar();
    getR_clipWindow();
}

extern "C" {
void XtMoveWidget(
#if NeedFunctionPrototypes
    Widget 		/* widget */,
    Position		/* x */,
    Position 		/* y */
#endif /* NeedFunctionPrototypes */
);
}

void GnVariableScrolledWindow ::
scroll_to ( int x_offset, int y_offset )
{
    Gina_Debug("GnVariableScrolledWindow :: scroll_to ");
    Gina_Debug(x_offset);Gina_Debug(" ");Gina_Debug_NL(y_offset);
    XFlush( work_area->get_display() );
    XtMoveWidget( work_area->get_widget_id(), -x_offset, -y_offset );
    horizontal_scrollbar->setR_value( x_offset );
    horizontal_scrollbar->SetValues();
    vertical_scrollbar->setR_value( y_offset );
    vertical_scrollbar->SetValues();
}

Boolean GnVariableScrolledWindow ::
show_point( int x, int y ) // x,y: pointer position relative to view
{
    Gina_Debug("GnVariableScrolledWindow :: show_point ");
    Gina_Debug(x);Gina_Debug(" ");Gina_Debug_NL(y);
    Boolean do_scrolling = False;

    int old_x_offset = - work_area->getR_x();
    int old_y_offset = - work_area->getR_y();
    int new_x_offset = old_x_offset;
    int new_y_offset = old_y_offset;
    int clip_height, clip_width;

    if ( x < old_x_offset ) {
	do_scrolling = TRUE;
	new_x_offset = x;
    }
    else if( x >= ((clip_width = clip_window->getR_width()) + old_x_offset)) {
	do_scrolling = TRUE;
	new_x_offset = x - clip_width;
    }
    
    if ( y < old_y_offset ) {
	do_scrolling = TRUE;
	new_y_offset = y;
    }
    else if( y >= ((clip_height=clip_window->getR_height()) + old_y_offset)) {
	do_scrolling = TRUE;
	new_y_offset = y - clip_height;
    }
     
    if( do_scrolling )
	scroll_to( new_x_offset, new_y_offset);
    return do_scrolling;
}

Boolean GnVariableScrolledWindow ::
point_visible ( int x, int y )
{
    int old_x_offset = - work_area->getR_x();
    int old_y_offset = - work_area->getR_y();
    
    return ! ( (x < old_x_offset) || 
	       (y < old_y_offset) ||
	       (x >= (clip_window->getR_width() + old_x_offset)) ||
	       (y >= (clip_window->getR_height() + old_y_offset)) );
}

META_IMPL_1(GnStaticScrolledWindow,GnVariableScrolledWindow,);

Widget GnStaticScrolledWindow::create_widget(GnWidget *par, char *n)
{
    return(GnScrolledWindow::create_widget(par, n));
}

void GnStaticScrolledWindow::
before_create(GnWidget *)
{
    // Force Resources to specific values

    setR_scrollBarDisplayPolicy(XmSTATIC);
    setR_scrollingPolicy(XmAUTOMATIC);
    setR_visualPolicy(XmCONSTANT);
}

void GnStaticScrolledWindow::
after_create()
{
    GnVariableScrolledWindow::after_create();
}
