/* @(#)GnToolkit.C	1.5 2/25/91 */

META_IMPL_1(GnToolkit,GnObject,);

GnToolkit::GnToolkit(char *application_class, char *application_name)
: app_shell(this)
{
    app_class    = application_class ? application_class : "Motif";
    app_name     = application_name;
    display      = 0;
    app_context  = 0;
    uid  = getuid();
    euid = geteuid();
    gid  = getgid();
    egid = getegid();
}

Boolean GnToolkit::
AppInitialize(Cardinal *argc, char **argv, Boolean abort_on_error)
{
    XtToolkitInitialize();
    app_context = XtCreateApplicationContext();
    display = XtOpenDisplay(app_context, 0, app_name, app_class,
                            0, 0, argc, argv);
    if( display == NULL ) {
	if( abort_on_error )
	    abort();
	else
	    return(False);
    }
    app_shell.create(0, "");
    return(True);
}

void GnToolkit::
AppMainLoop()
{
    Require( display != 0 );
    Require( app_shell.get_widget_id() != 0 );

    Gina_Debug("AppContext ="); Gina_Debug_NL((void *)app_context);
    XtAppMainLoop(app_context);
}

XtErrorHandler GnToolkit::set_xt_error_handler(XtErrorHandler handler)
{
    Require(app_context != 0 );

    return(XtAppSetErrorHandler(app_context, handler));
}

XtErrorHandler GnToolkit::set_xt_warning_handler(XtErrorHandler handler)
{
    Require(app_context != 0 );

    return(XtAppSetWarningHandler(app_context, handler));
}

XErrorHandler GnToolkit::
set_x_error_handler(XErrorHandler handler)
{
    return(XSetErrorHandler(handler));
}
